=== src/swipl-devel/debian/control ===
Source: swi-prolog
Section: interpreters
Priority: optional
Maintainer: Jan Wielemaker <jan@swi-prolog.org>
Build-Depends:
 cmake,
 debhelper,
 ncurses-dev,
 libreadline-dev,
 libedit-dev,
 libgmp-dev,
 libjpeg8-dev,
 libx11-dev,
 libxpm-dev,
 libxt-dev,
 x11proto-core-dev,
 unixodbc-dev,
 default-jdk [alpha amd64 armel armhf i386 ia64 mips mipsel powerpc s390 s390x sparc],
 junit [alpha amd64 armel armhf i386 ia64 mips mipsel powerpc s390 s390x sparc],
 libxft-dev,
 libxext-dev,
 libice-dev,
 libxinerama-dev,
 dctrl-tools,
 libarchive-dev,
 libssl-dev,
 zlib1g-dev,
 libunwind-dev | libunwind8-dev | libunwind7-dev,
 libossp-uuid-dev,
 libdb-dev,
 libpcre2-dev,
 libyaml-dev,
 libjs-jquery,
 libpython3-dev,
 dh-autoreconf
Standards-Version: 3.9.4
Vcs-Git: git://git.debian.org/git/collab-maint/swi-prolog.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/swi-prolog.git
Homepage: http://www.swi-prolog.org

Package: swi-prolog
Architecture: any
Depends: ${misc:Depends}, swi-prolog-nox (= ${binary:Version}), swi-prolog-x (= ${binary:Version})
Suggests: prolog-el
Description: ISO/Edinburgh-style Prolog interpreter
 SWI-Prolog is a fast and powerful ISO/Edinburgh-style Prolog compiler with a
 rich set of built-in predicates. It offers a fast, robust and small
 environment which enables substantial applications to be developed with it.
 .
 SWI-Prolog additionally offers:
 .
  * A powerful module system
  * Garbage collection
  * Unicode character set handling
  * Unbounted integer and rational number arithmetic
  * Multithreading support
  * A powerful C/C++ interface
  * GNU Readline interface

Package: swi-prolog-nox
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libgmp-dev, libedit-dev, libreadline-dev, libncursesw5-dev, libjs-jquery
Breaks: swi-prolog (<< 5.8.2-1)
Suggests: prolog-el
Description: ISO/Edinburgh-style Prolog interpreter (without X support)
 SWI-Prolog is a fast and powerful ISO/Edinburgh-style Prolog compiler with a
 rich set of built-in predicates. It offers a fast, robust and small
 environment which enables substantial applications to be developed with it.
 .
 SWI-Prolog additionally offers:
 .
  * A powerful module system
  * Garbage collection
  * Unicode character set handling
  * Unbounted integer and rational number arithmetic
  * Multithreading support
  * A powerful C/C++ interface
  * GNU Readline interface
 .
 This package contains a working SWI-Prolog installation with GUI components.

Package: swi-prolog-x
Architecture: any
Depends: ${shlibs:Depends}, swi-prolog-nox (= ${binary:Version}), ${misc:Depends}
Description: User interface library for SWI-Prolog (with X support)
 SWI-Prolog is a fast and powerful ISO/Edinburgh-style Prolog compiler with a
 rich set of built-in predicates. It offers a fast, robust and small
 environment which enables substantial applications to be developed with it.
 .
 SWI-Prolog additionally offers:
 .
  * A powerful module system
  * Garbage collection
  * Unicode character set handling
  * Unbounted integer and rational number arithmetic
  * Multithreading support
  * A powerful C/C++ interface
  * GNU Readline interface
 .
 XPCE is an object-oriented symbolic programming environment for user
 interfaces. Although XPCE was designed to be language-independent, it has
 gained popularity most with Prolog.

Package: swi-prolog-java
Architecture: alpha amd64 armel armhf i386 ia64 mips mipsel powerpc s390 s390x sparc
Depends: ${shlibs:Depends}, swi-prolog-nox (= ${binary:Version}), ${misc:Depends}, default-jre-headless | java2-runtime
Description: Bidirectional interface between SWI-Prolog and Java
 SWI-Prolog is a fast and powerful ISO/Edinburgh-style Prolog compiler with a
 rich set of built-in predicates. It offers a fast, robust and small
 environment which enables substantial applications to be developed with it.
 .
 SWI-Prolog additionally offers:
 .
  * A powerful module system
  * Garbage collection
  * Unicode character set handling
  * Unbounted integer and rational number arithmetic
  * Multithreading support
  * A powerful C/C++ interface
  * GNU Readline interface
 .
 This library provides JPL, a bidirectional interface between SWI-Prolog and
 the Java 2 runtime.

Package: swi-prolog-odbc
Architecture: any
Depends: ${shlibs:Depends}, swi-prolog-nox (= ${binary:Version}), ${misc:Depends}
Description: ODBC library for SWI-Prolog
 SWI-Prolog is a fast and powerful ISO/Edinburgh-style Prolog compiler with a
 rich set of built-in predicates. It offers a fast, robust and small
 environment which enables substantial applications to be developed with it.
 .
 SWI-Prolog additionally offers:
 .
  * A powerful module system
  * Garbage collection
  * Unicode character set handling
  * Unbounted integer and rational number arithmetic
  * Multithreading support
  * A powerful C/C++ interface
  * GNU Readline interface
 .
 This package provides a foreign language extension to ODBC, a standard for
 interfacing with database systems.

Package: swi-prolog-bdb
Architecture: any
Depends: ${shlibs:Depends}, swi-prolog-nox (= ${binary:Version}), ${misc:Depends}
Description: Berkeley DB interface for SWI-Prolog
 SWI-Prolog is a fast and powerful ISO/Edinburgh-style Prolog compiler with a
 rich set of built-in predicates. It offers a fast, robust and small
 environment which enables substantial applications to be developed with it.
 .
 SWI-Prolog additionally offers:
 .
  * A powerful module system
  * Garbage collection
  * Unicode character set handling
  * Unbounted integer and rational number arithmetic
  * Multithreading support
  * A powerful C/C++ interface
  * GNU Readline interface
 .
 This package provides a foreign language extension to the Berkeley DB
 (libdb) embedded database.
