=== src/swipl-devel/debian/watch ===
version=4
http://www.swi-prolog.org/download/devel /download/devel/src/swipl-(.*)\.tar\.gz
