=== src/swipl-devel/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,12 @@
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
 
-if(CMAKE_C_COMPILER_ID STREQUAL Clang)
+# While GCC is good at optimization large   functions, MSVC is bad at it
+# and using VMI functions more then   doubles the performance. For Clang
+# the picture is less clear. The difference  is small, with a slight win
+# on either depending on CPU and workload.
+
+if(MSVC OR CMAKE_C_COMPILER_ID STREQUAL Clang)
   set(DEFAULT_VMI_FUNCTIONS ON)
 else()
   set(DEFAULT_VMI_FUNCTIONS OFF)
@@ -28,18 +33,6 @@
 option(USE_GMP
        "Use GNU MP Bignum library (LGPL)"
        ON)
-if(USE_GMP)
-  set(DEFAULT_USE_LIBBF OFF)
-else()
-  set(DEFAULT_USE_LIBBF ON)
-endif()
-option(USE_LIBBF
-       "Use LibBF for bignums (MIT)"
-       ${DEFAULT_USE_LIBBF})
-if(USE_GMP AND USE_LIBBF)
-  message(WARNING "Cannot use both libGMP and LibBF; using LibBF")
-  set(USE_GMP OFF)
-endif()
 if(APPLE)
 # tcmalloc breaks setlocale() on MacOS 12 (Monterey)
 option(USE_TCMALLOC
@@ -127,6 +120,16 @@
 include(PackageSelection)
 include(Dependencies)
 include(DocDepends)
+
+if(GMP_FOUND)
+  set(USE_LIBBF_DEFAULT OFF)
+else()
+  set(USE_LIBBF_DEFAULT ON)
+endif()
+
+option(USE_LIBBF
+       "Use LibBF for bignums (MIT)"
+       ${USE_LIBBF_DEFAULT})
 
 if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
   set_install_prefix()
@@ -206,7 +209,7 @@
 endif()
 
 set(SWIPL_BOOT_BASE        "boot.prc")
-set(SWIPL_BOOT_FILE        "${CMAKE_BINARY_DIR}/home/${SWIPL_BOOT_BASE}")
+set(SWIPL_BOOT_FILE        "${CMAKE_CURRENT_BINARY_DIR}/home/${SWIPL_BOOT_BASE}")
 set(SWIPL_INSTALL_LIBRARY  ${SWIPL_INSTALL_PREFIX}/library)
 set(SWIPL_INSTALL_BOOT     ${SWIPL_INSTALL_PREFIX}/boot)
 set(SWIPL_INSTALL_INCLUDE  ${SWIPL_INSTALL_PREFIX}/include)
@@ -255,8 +258,16 @@
 
 # Configuration we need everywhere
 if(MULTI_THREADED)
-  set(THREADS_PREFER_PTHREAD_FLAG TRUE)
-  find_package(Threads)
+  if(MSVC)
+    find_package(PThreads4W)
+  endif()
+  if(TARGET PThreads4W::PThreads4W)
+    add_library(Threads::Threads ALIAS PThreads4W::PThreads4W)
+    set(CMAKE_USE_PTHREADS_INIT ON)
+  else()
+    set(THREADS_PREFER_PTHREAD_FLAG TRUE)
+    find_package(Threads)
+  endif()
 endif()
 
 include(TestLargeFiles)
