=== src/swipl-devel/src/CMakeLists.txt ===
--- 
+++ 
@@ -33,6 +33,7 @@
 
 # Source locations
 get_filename_component(SWIPL_ROOT "${CMAKE_CURRENT_SOURCE_DIR}/.." ABSOLUTE)
+get_filename_component(SWIPL_BIN_ROOT "${CMAKE_CURRENT_BINARY_DIR}/.." ABSOLUTE)
 set(SWIPL_LIBRARY_ROOT ${SWIPL_ROOT}/library)
 set(SWIPL_BOOT_ROOT ${SWIPL_ROOT}/boot)
 
@@ -353,6 +354,6 @@
 config_data_files()
 
 # Set swipl.home above binaries to a relative path to the root
-file(WRITE "${CMAKE_BINARY_DIR}/swipl.home" "home\n")
-file(WRITE "${CMAKE_BINARY_DIR}/src/swipl.home" "../home\n")
-file(WRITE "${CMAKE_BINARY_DIR}/packages/swipl.home" "../home\n")
+file(WRITE "${SWIPL_BIN_ROOT}/swipl.home" "home\n")
+file(WRITE "${SWIPL_BIN_ROOT}/src/swipl.home" "../home\n")
+file(WRITE "${SWIPL_BIN_ROOT}/packages/swipl.home" "../home\n")
